unit Emulator;

{$mode objfpc}{$H+}


// soll mit GUI gearbeitet werden
{$DEFINE mit_GUI}




interface

uses
  Classes, SysUtils,

  {$IFDEF mit_GUI}
  MainForm_ram, MainForm_cpu, MainForm_trace,
  {$ENDIF}

  modul_ram, modul_cpu, modul_pio;

type


  TZ80 = class(TObject)
    constructor Create;
    destructor Destroy;
  private
    { private declarations }
    OP_Code : Byte;
  public
    { public declarations }
    Adress_Zeile, Befehl_Zeile, B_Zeile : String;
    Mode_Protokoll,
    Befehl_abgearbeitet : Boolean;
    Adresse_WORD : Word;
    procedure einen_Befehl_abarbeiten; { Abarbeiten eines Befehls and der Stelle des PC }
  end;


implementation

uses
  MainForm_EMUZ80, MainForm_buttons;



{ ##### Prozessor Z80 ##### }


constructor TZ80.Create;
begin

  Mode_Protokoll:=true;
  Befehl_abgearbeitet:=false;
  Befehl_Zeile:='';

end; { constructor TZ80.Create }







procedure TZ80.einen_Befehl_abarbeiten; { Abarbeiten eines Befehls and der Stelle des PC }
var
  temp_op_code : Byte;


  {$I emu_FLAGs.inc}

  {$I emu_00.inc}

  {$I emu_01.inc}

  {$I emu_02.inc}

  {$I emu_CB.inc}

  {$I emu_DD_CB.inc}

  {$I emu_DD.inc}

  {$I emu_ED.inc}

  {$I emu_FD_CB.inc}

  {$I emu_FD.inc}

  {$I emu_03.inc}



begin

  Befehl_abgearbeitet:=false;




  {$IFDEF mit_GUI}
  if Mode_Protokoll then begin
    Form_RAM.loesche_Mem_Red;
    Form_RAM.setze_Mem_Green(mod_cpu.Reg.SRS.PC);
    Form_cpu.Red_Reset;
    Form_cpu.Reg_Red.SRS.PC:=Farbe_Lesen;
    Befehl_Zeile:='';

  end; { if Mode_Protokoll then }
  {$ENDIF}


  Adress_Zeile:=IntToHex(mod_cpu.Reg.SRS.PC,4)+
                ' ('+IntToHex(mod_ram.Read_Byte(mod_cpu.Reg.SRS.PC),2)+')  ';


  OP_Code:=mod_ram.Read_Byte(mod_cpu.Reg.SRS.PC);
  INC(mod_cpu.Reg.SRS.PC);

  temp_op_code := OP_Code AND %11000000;

  case temp_op_code of

    %00000000 : OP_Code_00;

    %01000000 : OP_Code_01;

    %10000000 : OP_Code_10;

    %11000000 : OP_Code_11;

  end; { case temp_op_code of }





  {$IFDEF mit_GUI}
  if Mode_Protokoll then begin

    if Length(Befehl_Zeile)>0 then begin

      TForm_BUTTONS.Memo_Protokoll.Lines.Add(Adress_Zeile+Befehl_Zeile);

    end
    else begin

      TForm_BUTTONS.Memo_Protokoll.Lines.Add(Adress_Zeile+'### Fehler - Befehl nicht ausgewertet ###');

    end; { if Length(Befehl_Zeile)>0 then }

  end
  else begin

    // Fehlerbearbeitung im Konsolenmodus
    if not Befehl_abgearbeitet then begin

      Befehl_Zeile:=IntToHex(OP_Code,2)+'H';
      TForm_BUTTONS.Memo_Protokoll.Lines.Add(Adress_Zeile+Befehl_Zeile+'  ### Fehler - Befehl nicht ausgewertet ###');

    end; { if not Befehl_abgearbeitet then }

  end; { if Mode_Protokoll then }

  {$ELSE}

  // Fehlerbearbeitung im Konsolenmodus
  if not Befehl_abgearbeitet then begin

    Befehl_Zeile:=IntToHex(OP_Code,2)+'H';

  end; { if not Befehl_abgearbeitet then }


  {$ENDIF}




  {$IFDEF mit_GUI}
  if TForm_BUTTONS.CheckBox_BreakPoint.Checked then begin

    if mod_cpu.Reg.SRS.PC=Adresse_WORD then begin

      TForm_BUTTONS.Memo_Protokoll.Lines.Add('Abarbeitung bei Adresse: '+IntToHex(Adresse_WORD,4)+'H gestoppt');

      Mode_Protokoll:=true;
      Form_EMUZ80.EMU_Mode_Trace:=false;
      Form_EMUZ80.EMU_Mode_Run:=false;
      TForm_BUTTONS.Button_3_ein;

      if Form_EMUZ80.Form_TRACE_aktiv then
        Form_TRACE.ASM_Zeile_anzeigen(mod_cpu.Reg.SRS.PC);

    end; { if mod_cpu.Reg.SRS.PC=Adresse_WORD then }

  end; { if Form_EMUZ80.CheckBox_BreakPoint.Checked then }
  {$ENDIF}




end; { procedure TZ80.einen_Befehl_abarbeiten }





destructor TZ80.Destroy;
begin

end; { destructor TZ80.Destroy }



end.

